'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.call = call;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var CALL = typeof Symbol === 'function' ? Symbol('call') : '@@redux-call-effect/call';

function call(func) {
  for (var _len = arguments.length, params = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    params[_key - 1] = arguments[_key];
  }

  return {
    type: CALL,
    payload: {
      func: func,
      params: params
    }
  };
}

var callEffectMiddleware = exports.callEffectMiddleware = function callEffectMiddleware(_ref) {
  var dispatch = _ref.dispatch;
  return function (next) {
    return function (action) {
      if (action.type === CALL) {
        var _action$payload = action.payload,
            func = _action$payload.func,
            params = _action$payload.params;

        return dispatch(func.apply(undefined, _toConsumableArray(params)));
      }

      return next(action);
    };
  };
};